// Generated by Bisonc++ V6.07.00 on Sun, 24 Mar 2024 11:07:50 +0100

// base/comment

// $insert class.ih
#include "parser.ih"

// The FIRST element of SR arrays shown below uses `d_type', defining the
// state's type, and `d_lastIdx' containing the last element's index. If
// d_lastIdx contains the REQ_TOKEN bitflag (see below) then the state needs
// a token: if in this state d_token is Reserved_::UNDETERMINED_, nextToken() will be
// called

// The LAST element of SR arrays uses `d_token' containing the last retrieved
// token to speed up the (linear) seach.  Except for the first element of SR
// arrays, the field `d_action' is used to determine what to do next. If
// positive, it represents the next state (used with SHIFT); if zero, it
// indicates `ACCEPT', if negative, -d_action represents the number of the
// rule to reduce to.

// `lookup()' tries to find d_token in the current SR array. If it fails, and
// there is no default reduction UNEXPECTED_TOKEN_ is thrown, which is then
// caught by the error-recovery function.

// The error-recovery function will pop elements off the stack until a state
// having bit flag ERR_ITEM is found. This state has a transition on errTok_
// which is applied. In this errTok_ state, while the current token is not a
// proper continuation, new tokens are obtained by nextToken(). If such a
// token is found, error recovery is successful and the token is
// handled according to the error state's SR table and parsing continues.
// During error recovery semantic actions are ignored.

// A state flagged with the DEF_RED flag will perform a default
// reduction if no other continuations are available for the current token.

// The ACCEPT STATE never shows a default reduction: when it is reached the
// parser returns ACCEPT(). During the grammar
// analysis phase a default reduction may have been defined, but it is
// removed during the state-definition phase.

// So:
//      s_x[] = 
//      {
//                  [_field_1_]         [_field_2_]
//
// First element:   {state-type,        idx of last element},
// Other elements:  {required token,    action to perform},
//                                      ( < 0: reduce, 
//                                          0: ACCEPT,
//                                        > 0: next state)
//      }

// base/declarations
// $insert debugincludes
#include <iostream>
#include <sstream>
#include <string>
#include <iomanip>
#include <unordered_map>

namespace // anonymous
{
    char const author[] = "Frank B. Brokken (f.b.brokken@rug.nl)";

    enum Reserved_
    {
        UNDETERMINED_   = -2,
        EOF_            = -1,
        errTok_         = 256
    };
    enum StateType       // modify statetype/data.cc when this enum changes
    {
        NORMAL,
        ERR_ITEM,
        REQ_TOKEN,
        ERR_REQ,    // ERR_ITEM | REQ_TOKEN
        DEF_RED,    // state having default reduction
        ERR_DEF,    // ERR_ITEM | DEF_RED
        REQ_DEF,    // REQ_TOKEN | DEF_RED
        ERR_REQ_DEF // ERR_ITEM | REQ_TOKEN | DEF_RED
    };    
    inline bool operator&(StateType lhs, StateType rhs)
    {
        return (static_cast<int>(lhs) & rhs) != 0;
    }
    enum StateTransition
    {
        ACCEPT_   = 0,     // `ACCEPT' TRANSITION
    };

    struct PI_     // Production Info
    {
        size_t d_nonTerm; // identification number of this production's
                            // non-terminal 
        size_t d_size;    // number of elements in this production 
    };

    struct SR_     // Shift Reduce info, see its description above
    {
        union
        {
            int _field_1_;      // initializer, allowing initializations 
                                // of the SR s_[] arrays
            StateType d_type;
            int       d_token;
        };
        union
        {
            int _field_2_;

            int d_lastIdx;          // if negative, the state uses SHIFT
            int d_action;           // may be negative (reduce), 
                                    // postive (shift), or 0 (accept)
        };
    };

    // $insert staticdata
    
    enum                        // size to expand the state-stack with when
    {                           // full
        STACK_EXPANSION_ = 10
    };

// Productions Info Records:
PI_ const s_productionInfo[] = 
{
     {0, 0}, // not used: reduction values are negative
     {313, 3}, // 1: input ->  opt_directives section_delimiter rules
     {315, 2}, // 2: section_delimiter (SECTION_DELIMITER) ->  SECTION_DELIMITER '\x0a'
     {317, 1}, // 3: identifier (IDENTIFIER) ->  IDENTIFIER
     {318, 0}, // 4: _sc_name ->  <empty>
     {319, 2}, // 5: _start_condition_type (INCL_START_CONDITION) ->  INCL_START_CONDITION _sc_name
     {319, 2}, // 6: _start_condition_type (EXCL_START_CONDITION) ->  EXCL_START_CONDITION _sc_name
     {320, 2}, // 7: _start_condition_names ->  _start_condition_names identifier
     {320, 1}, // 8: _start_condition_names ->  identifier
     {321, 2}, // 9: _start_condition_directive ->  _start_condition_type _start_condition_names
     {322, 1}, // 10: _name_def ->  identifier
     {323, 1}, // 11: _stringType (STRING) ->  STRING
     {323, 1}, // 12: _stringType (RAWSTRING) ->  RAWSTRING
     {324, 2}, // 13: _name_definition ->  _name_def _stringType
     {325, 1}, // 14: _directive ->  option
     {325, 1}, // 15: _directive ->  _start_condition_directive
     {325, 1}, // 16: _directive ->  _name_definition
     {325, 1}, // 17: _directive (errTok_) ->  errTok_
     {325, 0}, // 18: _directive ->  <empty>
     {327, 2}, // 19: _directive_line ('\x0a') ->  _directive '\x0a'
     {314, 2}, // 20: opt_directives ->  opt_directives _directive_line
     {314, 0}, // 21: opt_directives ->  <empty>
     {328, 1}, // 22: _baseclassheader (BASECLASSHEADER) ->  BASECLASSHEADER
     {329, 1}, // 23: _baseclasspreinclude (BASECLASSPREINCLUDE) ->  BASECLASSPREINCLUDE
     {330, 1}, // 24: _classheader (CLASSHEADER) ->  CLASSHEADER
     {331, 1}, // 25: _classname (CLASSNAME) ->  CLASSNAME
     {332, 1}, // 26: _filenames (FILENAMES) ->  FILENAMES
     {333, 1}, // 27: _implementationheader (IMPLEMENTATIONHEADER) ->  IMPLEMENTATIONHEADER
     {334, 1}, // 28: _inputinline (INPUTINLINE) ->  INPUTINLINE
     {335, 1}, // 29: _inputinterface (INPUTINTERFACE) ->  INPUTINTERFACE
     {336, 1}, // 30: _inputimplementation (INPUTIMPLEMENTATION) ->  INPUTIMPLEMENTATION
     {337, 1}, // 31: _lexfunctionname (LEXFUNCTIONNAME) ->  LEXFUNCTIONNAME
     {338, 1}, // 32: _lexsource (LEXSOURCE) ->  LEXSOURCE
     {339, 1}, // 33: _namespace (NAMESPACE) ->  NAMESPACE
     {340, 1}, // 34: _skeleton_directory (SKELETON_DIRECTORY) ->  SKELETON_DIRECTORY
     {341, 1}, // 35: _startcondition_name (STARTCONDITION) ->  STARTCONDITION
     {342, 1}, // 36: _target_directory (TARGET_DIRECTORY) ->  TARGET_DIRECTORY
     {343, 1}, // 37: _stringOrIdent (STRING) ->  STRING
     {343, 1}, // 38: _stringOrIdent (IDENTIFIER) ->  IDENTIFIER
     {343, 1}, // 39: _stringOrIdent (RAWSTRING) ->  RAWSTRING
     {344, 0}, // 40: _opt_is ->  <empty>
     {344, 1}, // 41: _opt_is ('=') ->  '='
     {326, 3}, // 42: option ->  _inputinterface _opt_is _stringOrIdent
     {326, 3}, // 43: option ->  _inputimplementation _opt_is _stringOrIdent
     {326, 3}, // 44: option ->  _inputinline _opt_is _stringOrIdent
     {326, 3}, // 45: option ->  _classname _opt_is _stringOrIdent
     {326, 3}, // 46: option ->  _filenames _opt_is _stringOrIdent
     {326, 3}, // 47: option ->  _lexfunctionname _opt_is _stringOrIdent
     {326, 3}, // 48: option ->  _baseclassheader _opt_is _stringOrIdent
     {326, 3}, // 49: option ->  _baseclasspreinclude _opt_is _stringOrIdent
     {326, 3}, // 50: option ->  _classheader _opt_is _stringOrIdent
     {326, 3}, // 51: option ->  _implementationheader _opt_is _stringOrIdent
     {326, 3}, // 52: option ->  _lexsource _opt_is _stringOrIdent
     {326, 3}, // 53: option ->  _skeleton_directory _opt_is _stringOrIdent
     {326, 3}, // 54: option ->  _startcondition_name _opt_is _stringOrIdent
     {326, 3}, // 55: option ->  _target_directory _opt_is _stringOrIdent
     {326, 3}, // 56: option ->  _namespace _opt_is _stringOrIdent
     {326, 1}, // 57: option (CASEINSENSITIVE) ->  CASEINSENSITIVE
     {326, 1}, // 58: option (INTERACTIVE) ->  INTERACTIVE
     {326, 1}, // 59: option (PRINT) ->  PRINT
     {326, 1}, // 60: option (NOLINES) ->  NOLINES
     {326, 1}, // 61: option (DEBUG) ->  DEBUG
     {345, 1}, // 62: combi_chars (',') ->  ','
     {345, 1}, // 63: combi_chars ('=') ->  '='
     {345, 1}, // 64: combi_chars ('-') ->  '-'
     {345, 1}, // 65: combi_chars (''') ->  '''
     {346, 1}, // 66: _ms_name ->  identifier
     {347, 3}, // 67: _ms_name_list (',') ->  _ms_name_list ',' _ms_name
     {347, 1}, // 68: _ms_name_list ->  _ms_name
     {348, 1}, // 69: _ms_specs ('*') ->  '*'
     {348, 1}, // 70: _ms_specs ->  _ms_name_list
     {349, 1}, // 71: _ms_angular ('<') ->  '<'
     {350, 3}, // 72: ms_spec ('>') ->  _ms_angular _ms_specs '>'
     {351, 0}, // 73: _m_content ->  <empty>
     {352, 2}, // 74: _cc_start (CC_START) ->  CC_START _m_content
     {353, 2}, // 75: _cc_negated (CC_NEGATED) ->  CC_NEGATED _m_content
     {354, 1}, // 76: _cc_end (']') ->  ']'
     {355, 1}, // 77: _cc_literal ('/') ->  '/'
     {355, 1}, // 78: _cc_literal ('|') ->  '|'
     {355, 1}, // 79: _cc_literal ('(') ->  '('
     {355, 1}, // 80: _cc_literal (')') ->  ')'
     {355, 1}, // 81: _cc_literal ('*') ->  '*'
     {355, 1}, // 82: _cc_literal ('+') ->  '+'
     {355, 1}, // 83: _cc_literal ('?') ->  '?'
     {355, 1}, // 84: _cc_literal ('{') ->  '{'
     {355, 1}, // 85: _cc_literal ('}') ->  '}'
     {355, 1}, // 86: _cc_literal ('<') ->  '<'
     {355, 1}, // 87: _cc_literal ('>') ->  '>'
     {355, 1}, // 88: _cc_literal ('[') ->  '['
     {355, 1}, // 89: _cc_literal ('.') ->  '.'
     {355, 1}, // 90: _cc_literal ('^') ->  '^'
     {355, 1}, // 91: _cc_literal ('$') ->  '$'
     {355, 1}, // 92: _cc_literal (DOLLAR) ->  DOLLAR
     {355, 1}, // 93: _cc_literal (DECIMAL) ->  DECIMAL
     {355, 1}, // 94: _cc_literal (IDENTIFIER) ->  IDENTIFIER
     {355, 1}, // 95: _cc_literal (CHAR) ->  CHAR
     {355, 1}, // 96: _cc_literal (STRING) ->  STRING
     {355, 1}, // 97: _cc_literal ->  combi_chars
     {356, 1}, // 98: _cc_escape (ESCAPE_SEQUENCE) ->  ESCAPE_SEQUENCE
     {356, 1}, // 99: _cc_escape (QUOTES) ->  QUOTES
     {357, 1}, // 100: _cc_element ->  _cc_escape
     {357, 1}, // 101: _cc_element (PREDEFINED_CLASS) ->  PREDEFINED_CLASS
     {357, 1}, // 102: _cc_element ->  _cc_literal
     {358, 2}, // 103: _cc_content ->  _cc_content _cc_element
     {358, 1}, // 104: _cc_content ->  _cc_element
     {359, 2}, // 105: _cc_set ->  _cc_start _cc_end
     {359, 2}, // 106: _cc_set ->  _cc_negated _cc_end
     {359, 3}, // 107: _cc_set ->  _cc_start _cc_content _cc_end
     {359, 3}, // 108: _cc_set ->  _cc_negated _cc_content _cc_end
     {360, 3}, // 109: characterclass (CC_PLUS) ->  characterclass CC_PLUS characterclass
     {360, 3}, // 110: characterclass (CC_MINUS) ->  characterclass CC_MINUS characterclass
     {360, 1}, // 111: characterclass ->  _cc_set
     {361, 1}, // 112: _decimal (DECIMAL) ->  DECIMAL
     {362, 1}, // 113: _interval ->  _decimal
     {362, 3}, // 114: _interval (',') ->  _decimal ',' _decimal
     {362, 2}, // 115: _interval (',') ->  _decimal ','
     {363, 1}, // 116: _single_char (CHAR) ->  CHAR
     {363, 1}, // 117: _single_char ->  combi_chars
     {364, 1}, // 118: _open_paren ('(') ->  '('
     {365, 1}, // 119: _close_paren (')') ->  ')'
     {366, 1}, // 120: _open_curly ('{') ->  '{'
     {367, 1}, // 121: _unit ('^') ->  '^'
     {367, 1}, // 122: _unit ('$') ->  '$'
     {367, 1}, // 123: _unit (DOLLAR) ->  DOLLAR
     {367, 1}, // 124: _unit (STRING) ->  STRING
     {367, 1}, // 125: _unit (RAWSTRING) ->  RAWSTRING
     {367, 1}, // 126: _unit (QUOTES) ->  QUOTES
     {367, 1}, // 127: _unit (ESCAPE_SEQUENCE) ->  ESCAPE_SEQUENCE
     {367, 1}, // 128: _unit ('.') ->  '.'
     {367, 1}, // 129: _unit ->  _single_char
     {367, 1}, // 130: _unit ->  characterclass
     {368, 1}, // 131: _quantifier ('*') ->  '*'
     {368, 1}, // 132: _quantifier ('+') ->  '+'
     {368, 1}, // 133: _quantifier ('?') ->  '?'
     {369, 1}, // 134: _regex_unit ->  _unit
     {369, 4}, // 135: _regex_unit ('}') ->  _regex_unit _open_curly _interval '}'
     {369, 2}, // 136: _regex_unit ->  _regex_unit _quantifier
     {369, 3}, // 137: _regex_unit ->  _open_paren _regex _close_paren
     {369, 2}, // 138: _regex_unit (CHAR) ->  _regex_unit _regex_unit
     {370, 1}, // 139: _regex ->  _regex_unit
     {370, 3}, // 140: _regex ('|') ->  _regex '|' _regex
     {370, 3}, // 141: _regex ('/') ->  _regex '/' _regex
     {371, 1}, // 142: regexOrEOF ->  _regex
     {371, 1}, // 143: regexOrEOF (EOF_PATTERN) ->  EOF_PATTERN
     {372, 1}, // 144: action (BLOCK) ->  BLOCK
     {373, 0}, // 145: reset ->  <empty>
     {374, 5}, // 146: _msCompound_regex_list (ORNL) ->  _msCompound_regex_list ORNL '\x0a' reset _msCompound_regex_list
     {374, 1}, // 147: _msCompound_regex_list ->  regexOrEOF
     {375, 0}, // 148: _msCompound_rule ->  <empty>
     {375, 1}, // 149: _msCompound_rule ->  _msCompound_regex_list
     {375, 2}, // 150: _msCompound_rule ->  _msCompound_regex_list action
     {376, 3}, // 151: _msCompound_nl_rule ('\x0a') ->  _msCompound_rule '\x0a' reset
     {377, 0}, // 152: _opt_msCompound_nl_rules ->  <empty>
     {377, 2}, // 153: _opt_msCompound_nl_rules ->  _opt_msCompound_nl_rules _msCompound_nl_rule
     {378, 5}, // 154: msCompound ('{') ->  ms_spec '{' reset _opt_msCompound_nl_rules '}'
     {379, 3}, // 155: _optMs_regex ->  ms_spec reset regexOrEOF
     {379, 1}, // 156: _optMs_regex ->  regexOrEOF
     {380, 5}, // 157: _optMs_rule (ORNL) ->  _optMs_rule ORNL '\x0a' reset _optMs_rule
     {380, 1}, // 158: _optMs_rule ->  _optMs_regex
     {381, 1}, // 159: optMs_rule ->  _optMs_rule
     {381, 2}, // 160: optMs_rule ->  _optMs_rule action
     {382, 0}, // 161: _rule_def ->  <empty>
     {382, 1}, // 162: _rule_def (errTok_) ->  errTok_
     {382, 1}, // 163: _rule_def ->  optMs_rule
     {382, 1}, // 164: _rule_def ->  msCompound
     {383, 3}, // 165: _rule ('\x0a') ->  _rule_def '\x0a' reset
     {316, 2}, // 166: rules ->  rules _rule
     {316, 0}, // 167: rules ->  <empty>
     {384, 1}, // 168: input_$ ->  input
};

// State info and SR_ transitions for each state.


SR_ s_0[] =
{
    { { DEF_RED}, {   3} },                  
    { {     313}, {   1} }, // input         
    { {     314}, {   2} }, // opt_directives
    { {       0}, { -21} },                  
};

SR_ s_1[] =
{
    { { REQ_TOKEN}, {       2} }, 
    { {      EOF_}, { ACCEPT_} }, 
    { {         0}, {       0} }, 
};

SR_ s_2[] =
{
    { { ERR_REQ_DEF}, {  50} },                              
    { {         315}, {   3} }, // section_delimiter         
    { {         327}, {   4} }, // _directive_line           
    { {         259}, {   5} }, // SECTION_DELIMITER         
    { {         325}, {   6} }, // _directive                
    { {         326}, {   7} }, // option                    
    { {         321}, {   8} }, // _start_condition_directive
    { {         324}, {   9} }, // _name_definition          
    { {     errTok_}, {  10} }, // errTok_                   
    { {         335}, {  11} }, // _inputinterface           
    { {         336}, {  12} }, // _inputimplementation      
    { {         334}, {  13} }, // _inputinline              
    { {         331}, {  14} }, // _classname                
    { {         332}, {  15} }, // _filenames                
    { {         337}, {  16} }, // _lexfunctionname          
    { {         328}, {  17} }, // _baseclassheader          
    { {         329}, {  18} }, // _baseclasspreinclude      
    { {         330}, {  19} }, // _classheader              
    { {         333}, {  20} }, // _implementationheader     
    { {         338}, {  21} }, // _lexsource                
    { {         340}, {  22} }, // _skeleton_directory       
    { {         341}, {  23} }, // _startcondition_name      
    { {         342}, {  24} }, // _target_directory         
    { {         339}, {  25} }, // _namespace                
    { {         262}, {  26} }, // CASEINSENSITIVE           
    { {         271}, {  27} }, // INTERACTIVE               
    { {         276}, {  28} }, // PRINT                     
    { {         275}, {  29} }, // NOLINES                   
    { {         265}, {  30} }, // DEBUG                     
    { {         319}, {  31} }, // _start_condition_type     
    { {         322}, {  32} }, // _name_def                 
    { {         270}, {  33} }, // INPUTINTERFACE            
    { {         268}, {  34} }, // INPUTIMPLEMENTATION       
    { {         269}, {  35} }, // INPUTINLINE               
    { {         264}, {  36} }, // CLASSNAME                 
    { {         266}, {  37} }, // FILENAMES                 
    { {         272}, {  38} }, // LEXFUNCTIONNAME           
    { {         260}, {  39} }, // BASECLASSHEADER           
    { {         261}, {  40} }, // BASECLASSPREINCLUDE       
    { {         263}, {  41} }, // CLASSHEADER               
    { {         267}, {  42} }, // IMPLEMENTATIONHEADER      
    { {         273}, {  43} }, // LEXSOURCE                 
    { {         277}, {  44} }, // SKELETON_DIRECTORY        
    { {         278}, {  45} }, // STARTCONDITION            
    { {         279}, {  46} }, // TARGET_DIRECTORY          
    { {         274}, {  47} }, // NAMESPACE                 
    { {         258}, {  48} }, // INCL_START_CONDITION      
    { {         257}, {  49} }, // EXCL_START_CONDITION      
    { {         317}, {  50} }, // identifier                
    { {         281}, {  51} }, // IDENTIFIER                
    { {           0}, { -18} },                              
};

SR_ s_3[] =
{
    { { DEF_RED}, {    2} },         
    { {     316}, {   52} }, // rules
    { {       0}, { -167} },         
};

SR_ s_4[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -20} }, 
};

SR_ s_5[] =
{
    { { REQ_TOKEN}, {  2} },          
    { {        10}, { 53} }, // '\x0a'
    { {         0}, {  0} },          
};

SR_ s_6[] =
{
    { { REQ_TOKEN}, {  2} },          
    { {        10}, { 54} }, // '\x0a'
    { {         0}, {  0} },          
};

SR_ s_7[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -14} }, 
};

SR_ s_8[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -15} }, 
};

SR_ s_9[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -16} }, 
};

SR_ s_10[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -17} }, 
};

SR_ s_11[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  55} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_12[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  57} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_13[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  58} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_14[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  59} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_15[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  60} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_16[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  61} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_17[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  62} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_18[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  63} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_19[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  64} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_20[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  65} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_21[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  66} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_22[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  67} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_23[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  68} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_24[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  69} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_25[] =
{
    { { REQ_DEF}, {   3} },           
    { {     344}, {  70} }, // _opt_is
    { {      61}, {  56} }, // '='    
    { {       0}, { -40} },           
};

SR_ s_26[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -57} }, 
};

SR_ s_27[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -58} }, 
};

SR_ s_28[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -59} }, 
};

SR_ s_29[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -60} }, 
};

SR_ s_30[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -61} }, 
};

SR_ s_31[] =
{
    { { REQ_TOKEN}, {  4} },                          
    { {       320}, { 71} }, // _start_condition_names
    { {       317}, { 72} }, // identifier            
    { {       281}, { 51} }, // IDENTIFIER            
    { {         0}, {  0} },                          
};

SR_ s_32[] =
{
    { { REQ_TOKEN}, {  4} },               
    { {       323}, { 73} }, // _stringType
    { {       284}, { 74} }, // STRING     
    { {       283}, { 75} }, // RAWSTRING  
    { {         0}, {  0} },               
};

SR_ s_33[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -29} }, 
};

SR_ s_34[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -30} }, 
};

SR_ s_35[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -28} }, 
};

SR_ s_36[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -25} }, 
};

SR_ s_37[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -26} }, 
};

SR_ s_38[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -31} }, 
};

SR_ s_39[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -22} }, 
};

SR_ s_40[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -23} }, 
};

SR_ s_41[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -24} }, 
};

SR_ s_42[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -27} }, 
};

SR_ s_43[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -32} }, 
};

SR_ s_44[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -34} }, 
};

SR_ s_45[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -35} }, 
};

SR_ s_46[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -36} }, 
};

SR_ s_47[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -33} }, 
};

SR_ s_48[] =
{
    { { DEF_RED}, {  2} },            
    { {     318}, { 76} }, // _sc_name
    { {       0}, { -4} },            
};

SR_ s_49[] =
{
    { { DEF_RED}, {  2} },            
    { {     318}, { 77} }, // _sc_name
    { {       0}, { -4} },            
};

SR_ s_50[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -10} }, 
};

SR_ s_51[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -3} }, 
};

SR_ s_52[] =
{
    { { ERR_REQ_DEF}, {   40} },                   
    { {         383}, {   78} }, // _rule          
    { {         382}, {   79} }, // _rule_def      
    { {     errTok_}, {   80} }, // errTok_        
    { {         381}, {   81} }, // optMs_rule     
    { {         378}, {   82} }, // msCompound     
    { {         380}, {   83} }, // _optMs_rule    
    { {         350}, {   84} }, // ms_spec        
    { {         379}, {   85} }, // _optMs_regex   
    { {         349}, {   86} }, // _ms_angular    
    { {         371}, {   87} }, // regexOrEOF     
    { {          60}, {   88} }, // '<'            
    { {         370}, {   89} }, // _regex         
    { {         282}, {   90} }, // EOF_PATTERN    
    { {         369}, {   91} }, // _regex_unit    
    { {         367}, {   92} }, // _unit          
    { {         364}, {   93} }, // _open_paren    
    { {          94}, {   94} }, // '^'            
    { {          36}, {   95} }, // '$'            
    { {         287}, {   96} }, // DOLLAR         
    { {         284}, {   97} }, // STRING         
    { {         283}, {   98} }, // RAWSTRING      
    { {         285}, {   99} }, // QUOTES         
    { {         288}, {  100} }, // ESCAPE_SEQUENCE
    { {          46}, {  101} }, // '.'            
    { {         363}, {  102} }, // _single_char   
    { {         360}, {  103} }, // characterclass 
    { {          40}, {  104} }, // '('            
    { {         293}, {  105} }, // CHAR           
    { {         345}, {  106} }, // combi_chars    
    { {         359}, {  107} }, // _cc_set        
    { {          44}, {  108} }, // ','            
    { {          61}, {  109} }, // '='            
    { {          45}, {  110} }, // '-'            
    { {          39}, {  111} }, // '''            
    { {         352}, {  112} }, // _cc_start      
    { {         353}, {  113} }, // _cc_negated    
    { {         289}, {  114} }, // CC_START       
    { {         290}, {  115} }, // CC_NEGATED     
    { {        EOF_}, {   -1} }, // EOF_           
    { {           0}, { -161} },                   
};

SR_ s_53[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -2} }, 
};

SR_ s_54[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -19} }, 
};

SR_ s_55[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 116} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_56[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -41} }, 
};

SR_ s_57[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 120} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_58[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 121} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_59[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 122} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_60[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 123} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_61[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 124} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_62[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 125} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_63[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 126} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_64[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 127} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_65[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 128} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_66[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 129} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_67[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 130} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_68[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 131} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_69[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 132} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_70[] =
{
    { { REQ_TOKEN}, {   5} },                  
    { {       343}, { 133} }, // _stringOrIdent
    { {       284}, { 117} }, // STRING        
    { {       281}, { 118} }, // IDENTIFIER    
    { {       283}, { 119} }, // RAWSTRING     
    { {         0}, {   0} },                  
};

SR_ s_71[] =
{
    { { REQ_DEF}, {   3} },              
    { {     317}, { 134} }, // identifier
    { {     281}, {  51} }, // IDENTIFIER
    { {       0}, {  -9} },              
};

SR_ s_72[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -8} }, 
};

SR_ s_73[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -13} }, 
};

SR_ s_74[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -11} }, 
};

SR_ s_75[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -12} }, 
};

SR_ s_76[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -5} }, 
};

SR_ s_77[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -6} }, 
};

SR_ s_78[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -166} }, 
};

SR_ s_79[] =
{
    { { REQ_TOKEN}, {   2} },          
    { {        10}, { 135} }, // '\x0a'
    { {         0}, {   0} },          
};

SR_ s_80[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -162} }, 
};

SR_ s_81[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -163} }, 
};

SR_ s_82[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -164} }, 
};

SR_ s_83[] =
{
    { { REQ_DEF}, {    4} },          
    { {     372}, {  136} }, // action
    { {     292}, {  137} }, // ORNL  
    { {     280}, {  138} }, // BLOCK 
    { {       0}, { -159} },          
};

SR_ s_84[] =
{
    { { REQ_DEF}, {    3} },         
    { {     123}, {  139} }, // '{'  
    { {     373}, {  140} }, // reset
    { {       0}, { -145} },         
};

SR_ s_85[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -158} }, 
};

SR_ s_86[] =
{
    { { REQ_TOKEN}, {   7} },                 
    { {       348}, { 141} }, // _ms_specs    
    { {        42}, { 142} }, // '*'          
    { {       347}, { 143} }, // _ms_name_list
    { {       346}, { 144} }, // _ms_name     
    { {       317}, { 145} }, // identifier   
    { {       281}, {  51} }, // IDENTIFIER   
    { {         0}, {   0} },                 
};

SR_ s_87[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -156} }, 
};

SR_ s_88[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -71} }, 
};

SR_ s_89[] =
{
    { { REQ_DEF}, {    3} },       
    { {     124}, {  146} }, // '|'
    { {      47}, {  147} }, // '/'
    { {       0}, { -142} },       
};

SR_ s_90[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -143} }, 
};

SR_ s_91[] =
{
    { { REQ_DEF}, {   32} },                   
    { {     366}, {  148} }, // _open_curly    
    { {     368}, {  149} }, // _quantifier    
    { {     369}, {  150} }, // _regex_unit    
    { {     123}, {  151} }, // '{'            
    { {      42}, {  152} }, // '*'            
    { {      43}, {  153} }, // '+'            
    { {      63}, {  154} }, // '?'            
    { {     367}, {   92} }, // _unit          
    { {     364}, {   93} }, // _open_paren    
    { {      94}, {   94} }, // '^'            
    { {      36}, {   95} }, // '$'            
    { {     287}, {   96} }, // DOLLAR         
    { {     284}, {   97} }, // STRING         
    { {     283}, {   98} }, // RAWSTRING      
    { {     285}, {   99} }, // QUOTES         
    { {     288}, {  100} }, // ESCAPE_SEQUENCE
    { {      46}, {  101} }, // '.'            
    { {     363}, {  102} }, // _single_char   
    { {     360}, {  103} }, // characterclass 
    { {      40}, {  104} }, // '('            
    { {     293}, {  105} }, // CHAR           
    { {     345}, {  106} }, // combi_chars    
    { {     359}, {  107} }, // _cc_set        
    { {      44}, {  108} }, // ','            
    { {      61}, {  109} }, // '='            
    { {      45}, {  110} }, // '-'            
    { {      39}, {  111} }, // '''            
    { {     352}, {  112} }, // _cc_start      
    { {     353}, {  113} }, // _cc_negated    
    { {     289}, {  114} }, // CC_START       
    { {     290}, {  115} }, // CC_NEGATED     
    { {       0}, { -139} },                   
};

SR_ s_92[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -134} }, 
};

SR_ s_93[] =
{
    { { REQ_TOKEN}, {  27} },                   
    { {       370}, { 155} }, // _regex         
    { {       369}, {  91} }, // _regex_unit    
    { {       367}, {  92} }, // _unit          
    { {       364}, {  93} }, // _open_paren    
    { {        94}, {  94} }, // '^'            
    { {        36}, {  95} }, // '$'            
    { {       287}, {  96} }, // DOLLAR         
    { {       284}, {  97} }, // STRING         
    { {       283}, {  98} }, // RAWSTRING      
    { {       285}, {  99} }, // QUOTES         
    { {       288}, { 100} }, // ESCAPE_SEQUENCE
    { {        46}, { 101} }, // '.'            
    { {       363}, { 102} }, // _single_char   
    { {       360}, { 103} }, // characterclass 
    { {        40}, { 104} }, // '('            
    { {       293}, { 105} }, // CHAR           
    { {       345}, { 106} }, // combi_chars    
    { {       359}, { 107} }, // _cc_set        
    { {        44}, { 108} }, // ','            
    { {        61}, { 109} }, // '='            
    { {        45}, { 110} }, // '-'            
    { {        39}, { 111} }, // '''            
    { {       352}, { 112} }, // _cc_start      
    { {       353}, { 113} }, // _cc_negated    
    { {       289}, { 114} }, // CC_START       
    { {       290}, { 115} }, // CC_NEGATED     
    { {         0}, {   0} },                   
};

SR_ s_94[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -121} }, 
};

SR_ s_95[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -122} }, 
};

SR_ s_96[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -123} }, 
};

SR_ s_97[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -124} }, 
};

SR_ s_98[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -125} }, 
};

SR_ s_99[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -126} }, 
};

SR_ s_100[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -127} }, 
};

SR_ s_101[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -128} }, 
};

SR_ s_102[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -129} }, 
};

SR_ s_103[] =
{
    { { REQ_DEF}, {    3} },            
    { {     294}, {  156} }, // CC_PLUS 
    { {     295}, {  157} }, // CC_MINUS
    { {       0}, { -130} },            
};

SR_ s_104[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -118} }, 
};

SR_ s_105[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -116} }, 
};

SR_ s_106[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -117} }, 
};

SR_ s_107[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -111} }, 
};

SR_ s_108[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -62} }, 
};

SR_ s_109[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -63} }, 
};

SR_ s_110[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -64} }, 
};

SR_ s_111[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -65} }, 
};

SR_ s_112[] =
{
    { { REQ_TOKEN}, {  35} },                    
    { {       354}, { 158} }, // _cc_end         
    { {       358}, { 159} }, // _cc_content     
    { {        93}, { 160} }, // ']'             
    { {       357}, { 161} }, // _cc_element     
    { {       356}, { 162} }, // _cc_escape      
    { {       291}, { 163} }, // PREDEFINED_CLASS
    { {       355}, { 164} }, // _cc_literal     
    { {       288}, { 165} }, // ESCAPE_SEQUENCE 
    { {       285}, { 166} }, // QUOTES          
    { {        47}, { 167} }, // '/'             
    { {       124}, { 168} }, // '|'             
    { {        40}, { 169} }, // '('             
    { {        41}, { 170} }, // ')'             
    { {        42}, { 171} }, // '*'             
    { {        43}, { 172} }, // '+'             
    { {        63}, { 173} }, // '?'             
    { {       123}, { 174} }, // '{'             
    { {       125}, { 175} }, // '}'             
    { {        60}, { 176} }, // '<'             
    { {        62}, { 177} }, // '>'             
    { {        91}, { 178} }, // '['             
    { {        46}, { 179} }, // '.'             
    { {        94}, { 180} }, // '^'             
    { {        36}, { 181} }, // '$'             
    { {       287}, { 182} }, // DOLLAR          
    { {       286}, { 183} }, // DECIMAL         
    { {       281}, { 184} }, // IDENTIFIER      
    { {       293}, { 185} }, // CHAR            
    { {       284}, { 186} }, // STRING          
    { {       345}, { 187} }, // combi_chars     
    { {        44}, { 108} }, // ','             
    { {        61}, { 109} }, // '='             
    { {        45}, { 110} }, // '-'             
    { {        39}, { 111} }, // '''             
    { {         0}, {   0} },                    
};

SR_ s_113[] =
{
    { { REQ_TOKEN}, {  35} },                    
    { {       354}, { 188} }, // _cc_end         
    { {       358}, { 189} }, // _cc_content     
    { {        93}, { 160} }, // ']'             
    { {       357}, { 161} }, // _cc_element     
    { {       356}, { 162} }, // _cc_escape      
    { {       291}, { 163} }, // PREDEFINED_CLASS
    { {       355}, { 164} }, // _cc_literal     
    { {       288}, { 165} }, // ESCAPE_SEQUENCE 
    { {       285}, { 166} }, // QUOTES          
    { {        47}, { 167} }, // '/'             
    { {       124}, { 168} }, // '|'             
    { {        40}, { 169} }, // '('             
    { {        41}, { 170} }, // ')'             
    { {        42}, { 171} }, // '*'             
    { {        43}, { 172} }, // '+'             
    { {        63}, { 173} }, // '?'             
    { {       123}, { 174} }, // '{'             
    { {       125}, { 175} }, // '}'             
    { {        60}, { 176} }, // '<'             
    { {        62}, { 177} }, // '>'             
    { {        91}, { 178} }, // '['             
    { {        46}, { 179} }, // '.'             
    { {        94}, { 180} }, // '^'             
    { {        36}, { 181} }, // '$'             
    { {       287}, { 182} }, // DOLLAR          
    { {       286}, { 183} }, // DECIMAL         
    { {       281}, { 184} }, // IDENTIFIER      
    { {       293}, { 185} }, // CHAR            
    { {       284}, { 186} }, // STRING          
    { {       345}, { 187} }, // combi_chars     
    { {        44}, { 108} }, // ','             
    { {        61}, { 109} }, // '='             
    { {        45}, { 110} }, // '-'             
    { {        39}, { 111} }, // '''             
    { {         0}, {   0} },                    
};

SR_ s_114[] =
{
    { { DEF_RED}, {   2} },              
    { {     351}, { 190} }, // _m_content
    { {       0}, { -73} },              
};

SR_ s_115[] =
{
    { { DEF_RED}, {   2} },              
    { {     351}, { 191} }, // _m_content
    { {       0}, { -73} },              
};

SR_ s_116[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -42} }, 
};

SR_ s_117[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -37} }, 
};

SR_ s_118[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -38} }, 
};

SR_ s_119[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -39} }, 
};

SR_ s_120[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -43} }, 
};

SR_ s_121[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -44} }, 
};

SR_ s_122[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -45} }, 
};

SR_ s_123[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -46} }, 
};

SR_ s_124[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -47} }, 
};

SR_ s_125[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -48} }, 
};

SR_ s_126[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -49} }, 
};

SR_ s_127[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -50} }, 
};

SR_ s_128[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -51} }, 
};

SR_ s_129[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -52} }, 
};

SR_ s_130[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -53} }, 
};

SR_ s_131[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -54} }, 
};

SR_ s_132[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -55} }, 
};

SR_ s_133[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -56} }, 
};

SR_ s_134[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -7} }, 
};

SR_ s_135[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  192} }, // reset
    { {       0}, { -145} },         
};

SR_ s_136[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -160} }, 
};

SR_ s_137[] =
{
    { { REQ_TOKEN}, {   2} },          
    { {        10}, { 193} }, // '\x0a'
    { {         0}, {   0} },          
};

SR_ s_138[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -144} }, 
};

SR_ s_139[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  194} }, // reset
    { {       0}, { -145} },         
};

SR_ s_140[] =
{
    { { REQ_TOKEN}, {  29} },                   
    { {       371}, { 195} }, // regexOrEOF     
    { {       370}, {  89} }, // _regex         
    { {       282}, {  90} }, // EOF_PATTERN    
    { {       369}, {  91} }, // _regex_unit    
    { {       367}, {  92} }, // _unit          
    { {       364}, {  93} }, // _open_paren    
    { {        94}, {  94} }, // '^'            
    { {        36}, {  95} }, // '$'            
    { {       287}, {  96} }, // DOLLAR         
    { {       284}, {  97} }, // STRING         
    { {       283}, {  98} }, // RAWSTRING      
    { {       285}, {  99} }, // QUOTES         
    { {       288}, { 100} }, // ESCAPE_SEQUENCE
    { {        46}, { 101} }, // '.'            
    { {       363}, { 102} }, // _single_char   
    { {       360}, { 103} }, // characterclass 
    { {        40}, { 104} }, // '('            
    { {       293}, { 105} }, // CHAR           
    { {       345}, { 106} }, // combi_chars    
    { {       359}, { 107} }, // _cc_set        
    { {        44}, { 108} }, // ','            
    { {        61}, { 109} }, // '='            
    { {        45}, { 110} }, // '-'            
    { {        39}, { 111} }, // '''            
    { {       352}, { 112} }, // _cc_start      
    { {       353}, { 113} }, // _cc_negated    
    { {       289}, { 114} }, // CC_START       
    { {       290}, { 115} }, // CC_NEGATED     
    { {         0}, {   0} },                   
};

SR_ s_141[] =
{
    { { REQ_TOKEN}, {   2} },       
    { {        62}, { 196} }, // '>'
    { {         0}, {   0} },       
};

SR_ s_142[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -69} }, 
};

SR_ s_143[] =
{
    { { REQ_DEF}, {   2} },       
    { {      44}, { 197} }, // ','
    { {       0}, { -70} },       
};

SR_ s_144[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -68} }, 
};

SR_ s_145[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -66} }, 
};

SR_ s_146[] =
{
    { { REQ_TOKEN}, {  27} },                   
    { {       370}, { 198} }, // _regex         
    { {       369}, {  91} }, // _regex_unit    
    { {       367}, {  92} }, // _unit          
    { {       364}, {  93} }, // _open_paren    
    { {        94}, {  94} }, // '^'            
    { {        36}, {  95} }, // '$'            
    { {       287}, {  96} }, // DOLLAR         
    { {       284}, {  97} }, // STRING         
    { {       283}, {  98} }, // RAWSTRING      
    { {       285}, {  99} }, // QUOTES         
    { {       288}, { 100} }, // ESCAPE_SEQUENCE
    { {        46}, { 101} }, // '.'            
    { {       363}, { 102} }, // _single_char   
    { {       360}, { 103} }, // characterclass 
    { {        40}, { 104} }, // '('            
    { {       293}, { 105} }, // CHAR           
    { {       345}, { 106} }, // combi_chars    
    { {       359}, { 107} }, // _cc_set        
    { {        44}, { 108} }, // ','            
    { {        61}, { 109} }, // '='            
    { {        45}, { 110} }, // '-'            
    { {        39}, { 111} }, // '''            
    { {       352}, { 112} }, // _cc_start      
    { {       353}, { 113} }, // _cc_negated    
    { {       289}, { 114} }, // CC_START       
    { {       290}, { 115} }, // CC_NEGATED     
    { {         0}, {   0} },                   
};

SR_ s_147[] =
{
    { { REQ_TOKEN}, {  27} },                   
    { {       370}, { 199} }, // _regex         
    { {       369}, {  91} }, // _regex_unit    
    { {       367}, {  92} }, // _unit          
    { {       364}, {  93} }, // _open_paren    
    { {        94}, {  94} }, // '^'            
    { {        36}, {  95} }, // '$'            
    { {       287}, {  96} }, // DOLLAR         
    { {       284}, {  97} }, // STRING         
    { {       283}, {  98} }, // RAWSTRING      
    { {       285}, {  99} }, // QUOTES         
    { {       288}, { 100} }, // ESCAPE_SEQUENCE
    { {        46}, { 101} }, // '.'            
    { {       363}, { 102} }, // _single_char   
    { {       360}, { 103} }, // characterclass 
    { {        40}, { 104} }, // '('            
    { {       293}, { 105} }, // CHAR           
    { {       345}, { 106} }, // combi_chars    
    { {       359}, { 107} }, // _cc_set        
    { {        44}, { 108} }, // ','            
    { {        61}, { 109} }, // '='            
    { {        45}, { 110} }, // '-'            
    { {        39}, { 111} }, // '''            
    { {       352}, { 112} }, // _cc_start      
    { {       353}, { 113} }, // _cc_negated    
    { {       289}, { 114} }, // CC_START       
    { {       290}, { 115} }, // CC_NEGATED     
    { {         0}, {   0} },                   
};

SR_ s_148[] =
{
    { { REQ_TOKEN}, {   4} },             
    { {       362}, { 200} }, // _interval
    { {       361}, { 201} }, // _decimal 
    { {       286}, { 202} }, // DECIMAL  
    { {         0}, {   0} },             
};

SR_ s_149[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -136} }, 
};

SR_ s_150[] =
{
    { { REQ_DEF}, {   16} },                  
    { {     366}, {  148} }, // _open_curly   
    { {     368}, {  149} }, // _quantifier   
    { {     369}, {  150} }, // _regex_unit   
    { {     123}, {  151} }, // '{'           
    { {      42}, {  152} }, // '*'           
    { {      43}, {  153} }, // '+'           
    { {      63}, {  154} }, // '?'           
    { {     367}, {   92} }, // _unit         
    { {     364}, {   93} }, // _open_paren   
    { {     363}, {  102} }, // _single_char  
    { {     360}, {  103} }, // characterclass
    { {     345}, {  106} }, // combi_chars   
    { {     359}, {  107} }, // _cc_set       
    { {     352}, {  112} }, // _cc_start     
    { {     353}, {  113} }, // _cc_negated   
    { {       0}, { -138} },                  
};

SR_ s_151[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -120} }, 
};

SR_ s_152[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -131} }, 
};

SR_ s_153[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -132} }, 
};

SR_ s_154[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -133} }, 
};

SR_ s_155[] =
{
    { { REQ_TOKEN}, {   5} },                
    { {       365}, { 203} }, // _close_paren
    { {       124}, { 146} }, // '|'         
    { {        47}, { 147} }, // '/'         
    { {        41}, { 204} }, // ')'         
    { {         0}, {   0} },                
};

SR_ s_156[] =
{
    { { REQ_TOKEN}, {   7} },                  
    { {       360}, { 205} }, // characterclass
    { {       359}, { 107} }, // _cc_set       
    { {       352}, { 112} }, // _cc_start     
    { {       353}, { 113} }, // _cc_negated   
    { {       289}, { 114} }, // CC_START      
    { {       290}, { 115} }, // CC_NEGATED    
    { {         0}, {   0} },                  
};

SR_ s_157[] =
{
    { { REQ_TOKEN}, {   7} },                  
    { {       360}, { 206} }, // characterclass
    { {       359}, { 107} }, // _cc_set       
    { {       352}, { 112} }, // _cc_start     
    { {       353}, { 113} }, // _cc_negated   
    { {       289}, { 114} }, // CC_START      
    { {       290}, { 115} }, // CC_NEGATED    
    { {         0}, {   0} },                  
};

SR_ s_158[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -105} }, 
};

SR_ s_159[] =
{
    { { REQ_TOKEN}, {  34} },                    
    { {       354}, { 207} }, // _cc_end         
    { {       357}, { 208} }, // _cc_element     
    { {        93}, { 160} }, // ']'             
    { {       356}, { 162} }, // _cc_escape      
    { {       291}, { 163} }, // PREDEFINED_CLASS
    { {       355}, { 164} }, // _cc_literal     
    { {       288}, { 165} }, // ESCAPE_SEQUENCE 
    { {       285}, { 166} }, // QUOTES          
    { {        47}, { 167} }, // '/'             
    { {       124}, { 168} }, // '|'             
    { {        40}, { 169} }, // '('             
    { {        41}, { 170} }, // ')'             
    { {        42}, { 171} }, // '*'             
    { {        43}, { 172} }, // '+'             
    { {        63}, { 173} }, // '?'             
    { {       123}, { 174} }, // '{'             
    { {       125}, { 175} }, // '}'             
    { {        60}, { 176} }, // '<'             
    { {        62}, { 177} }, // '>'             
    { {        91}, { 178} }, // '['             
    { {        46}, { 179} }, // '.'             
    { {        94}, { 180} }, // '^'             
    { {        36}, { 181} }, // '$'             
    { {       287}, { 182} }, // DOLLAR          
    { {       286}, { 183} }, // DECIMAL         
    { {       281}, { 184} }, // IDENTIFIER      
    { {       293}, { 185} }, // CHAR            
    { {       284}, { 186} }, // STRING          
    { {       345}, { 187} }, // combi_chars     
    { {        44}, { 108} }, // ','             
    { {        61}, { 109} }, // '='             
    { {        45}, { 110} }, // '-'             
    { {        39}, { 111} }, // '''             
    { {         0}, {   0} },                    
};

SR_ s_160[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -76} }, 
};

SR_ s_161[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -104} }, 
};

SR_ s_162[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -100} }, 
};

SR_ s_163[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -101} }, 
};

SR_ s_164[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -102} }, 
};

SR_ s_165[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -98} }, 
};

SR_ s_166[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -99} }, 
};

SR_ s_167[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -77} }, 
};

SR_ s_168[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -78} }, 
};

SR_ s_169[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -79} }, 
};

SR_ s_170[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -80} }, 
};

SR_ s_171[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -81} }, 
};

SR_ s_172[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -82} }, 
};

SR_ s_173[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -83} }, 
};

SR_ s_174[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -84} }, 
};

SR_ s_175[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -85} }, 
};

SR_ s_176[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -86} }, 
};

SR_ s_177[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -87} }, 
};

SR_ s_178[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -88} }, 
};

SR_ s_179[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -89} }, 
};

SR_ s_180[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -90} }, 
};

SR_ s_181[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -91} }, 
};

SR_ s_182[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -92} }, 
};

SR_ s_183[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -93} }, 
};

SR_ s_184[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -94} }, 
};

SR_ s_185[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -95} }, 
};

SR_ s_186[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -96} }, 
};

SR_ s_187[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -97} }, 
};

SR_ s_188[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -106} }, 
};

SR_ s_189[] =
{
    { { REQ_TOKEN}, {  34} },                    
    { {       354}, { 209} }, // _cc_end         
    { {       357}, { 208} }, // _cc_element     
    { {        93}, { 160} }, // ']'             
    { {       356}, { 162} }, // _cc_escape      
    { {       291}, { 163} }, // PREDEFINED_CLASS
    { {       355}, { 164} }, // _cc_literal     
    { {       288}, { 165} }, // ESCAPE_SEQUENCE 
    { {       285}, { 166} }, // QUOTES          
    { {        47}, { 167} }, // '/'             
    { {       124}, { 168} }, // '|'             
    { {        40}, { 169} }, // '('             
    { {        41}, { 170} }, // ')'             
    { {        42}, { 171} }, // '*'             
    { {        43}, { 172} }, // '+'             
    { {        63}, { 173} }, // '?'             
    { {       123}, { 174} }, // '{'             
    { {       125}, { 175} }, // '}'             
    { {        60}, { 176} }, // '<'             
    { {        62}, { 177} }, // '>'             
    { {        91}, { 178} }, // '['             
    { {        46}, { 179} }, // '.'             
    { {        94}, { 180} }, // '^'             
    { {        36}, { 181} }, // '$'             
    { {       287}, { 182} }, // DOLLAR          
    { {       286}, { 183} }, // DECIMAL         
    { {       281}, { 184} }, // IDENTIFIER      
    { {       293}, { 185} }, // CHAR            
    { {       284}, { 186} }, // STRING          
    { {       345}, { 187} }, // combi_chars     
    { {        44}, { 108} }, // ','             
    { {        61}, { 109} }, // '='             
    { {        45}, { 110} }, // '-'             
    { {        39}, { 111} }, // '''             
    { {         0}, {   0} },                    
};

SR_ s_190[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -74} }, 
};

SR_ s_191[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -75} }, 
};

SR_ s_192[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -165} }, 
};

SR_ s_193[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  210} }, // reset
    { {       0}, { -145} },         
};

SR_ s_194[] =
{
    { { DEF_RED}, {    2} },                            
    { {     377}, {  211} }, // _opt_msCompound_nl_rules
    { {       0}, { -152} },                            
};

SR_ s_195[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -155} }, 
};

SR_ s_196[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -72} }, 
};

SR_ s_197[] =
{
    { { REQ_TOKEN}, {   4} },              
    { {       346}, { 212} }, // _ms_name  
    { {       317}, { 145} }, // identifier
    { {       281}, {  51} }, // IDENTIFIER
    { {         0}, {   0} },              
};

SR_ s_198[] =
{
    { { REQ_DEF}, {    1} }, 
    { {       0}, { -140} }, 
};

SR_ s_199[] =
{
    { { REQ_DEF}, {    2} },       
    { {     124}, {  146} }, // '|'
    { {       0}, { -141} },       
};

SR_ s_200[] =
{
    { { REQ_TOKEN}, {   2} },       
    { {       125}, { 213} }, // '}'
    { {         0}, {   0} },       
};

SR_ s_201[] =
{
    { { REQ_DEF}, {    2} },       
    { {      44}, {  214} }, // ','
    { {       0}, { -113} },       
};

SR_ s_202[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -112} }, 
};

SR_ s_203[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -137} }, 
};

SR_ s_204[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -119} }, 
};

SR_ s_205[] =
{
    { { REQ_DEF}, {    1} }, 
    { {       0}, { -109} }, 
};

SR_ s_206[] =
{
    { { REQ_DEF}, {    1} }, 
    { {       0}, { -110} }, 
};

SR_ s_207[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -107} }, 
};

SR_ s_208[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -103} }, 
};

SR_ s_209[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -108} }, 
};

SR_ s_210[] =
{
    { { REQ_TOKEN}, {  34} },                   
    { {       380}, { 215} }, // _optMs_rule    
    { {       379}, {  85} }, // _optMs_regex   
    { {       350}, { 216} }, // ms_spec        
    { {       371}, {  87} }, // regexOrEOF     
    { {       349}, {  86} }, // _ms_angular    
    { {       370}, {  89} }, // _regex         
    { {       282}, {  90} }, // EOF_PATTERN    
    { {        60}, {  88} }, // '<'            
    { {       369}, {  91} }, // _regex_unit    
    { {       367}, {  92} }, // _unit          
    { {       364}, {  93} }, // _open_paren    
    { {        94}, {  94} }, // '^'            
    { {        36}, {  95} }, // '$'            
    { {       287}, {  96} }, // DOLLAR         
    { {       284}, {  97} }, // STRING         
    { {       283}, {  98} }, // RAWSTRING      
    { {       285}, {  99} }, // QUOTES         
    { {       288}, { 100} }, // ESCAPE_SEQUENCE
    { {        46}, { 101} }, // '.'            
    { {       363}, { 102} }, // _single_char   
    { {       360}, { 103} }, // characterclass 
    { {        40}, { 104} }, // '('            
    { {       293}, { 105} }, // CHAR           
    { {       345}, { 106} }, // combi_chars    
    { {       359}, { 107} }, // _cc_set        
    { {        44}, { 108} }, // ','            
    { {        61}, { 109} }, // '='            
    { {        45}, { 110} }, // '-'            
    { {        39}, { 111} }, // '''            
    { {       352}, { 112} }, // _cc_start      
    { {       353}, { 113} }, // _cc_negated    
    { {       289}, { 114} }, // CC_START       
    { {       290}, { 115} }, // CC_NEGATED     
    { {         0}, {   0} },                   
};

SR_ s_211[] =
{
    { { REQ_DEF}, {   33} },                          
    { {     125}, {  217} }, // '}'                   
    { {     376}, {  218} }, // _msCompound_nl_rule   
    { {     375}, {  219} }, // _msCompound_rule      
    { {     374}, {  220} }, // _msCompound_regex_list
    { {     371}, {  221} }, // regexOrEOF            
    { {     370}, {   89} }, // _regex                
    { {     282}, {   90} }, // EOF_PATTERN           
    { {     369}, {   91} }, // _regex_unit           
    { {     367}, {   92} }, // _unit                 
    { {     364}, {   93} }, // _open_paren           
    { {      94}, {   94} }, // '^'                   
    { {      36}, {   95} }, // '$'                   
    { {     287}, {   96} }, // DOLLAR                
    { {     284}, {   97} }, // STRING                
    { {     283}, {   98} }, // RAWSTRING             
    { {     285}, {   99} }, // QUOTES                
    { {     288}, {  100} }, // ESCAPE_SEQUENCE       
    { {      46}, {  101} }, // '.'                   
    { {     363}, {  102} }, // _single_char          
    { {     360}, {  103} }, // characterclass        
    { {      40}, {  104} }, // '('                   
    { {     293}, {  105} }, // CHAR                  
    { {     345}, {  106} }, // combi_chars           
    { {     359}, {  107} }, // _cc_set               
    { {      44}, {  108} }, // ','                   
    { {      61}, {  109} }, // '='                   
    { {      45}, {  110} }, // '-'                   
    { {      39}, {  111} }, // '''                   
    { {     352}, {  112} }, // _cc_start             
    { {     353}, {  113} }, // _cc_negated           
    { {     289}, {  114} }, // CC_START              
    { {     290}, {  115} }, // CC_NEGATED            
    { {       0}, { -148} },                          
};

SR_ s_212[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -67} }, 
};

SR_ s_213[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -135} }, 
};

SR_ s_214[] =
{
    { { REQ_DEF}, {    3} },            
    { {     361}, {  222} }, // _decimal
    { {     286}, {  202} }, // DECIMAL 
    { {       0}, { -115} },            
};

SR_ s_215[] =
{
    { { REQ_DEF}, {    1} }, 
    { {       0}, { -157} }, 
};

SR_ s_216[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  140} }, // reset
    { {       0}, { -145} },         
};

SR_ s_217[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -154} }, 
};

SR_ s_218[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -153} }, 
};

SR_ s_219[] =
{
    { { REQ_TOKEN}, {   2} },          
    { {        10}, { 223} }, // '\x0a'
    { {         0}, {   0} },          
};

SR_ s_220[] =
{
    { { REQ_DEF}, {    4} },          
    { {     372}, {  224} }, // action
    { {     292}, {  225} }, // ORNL  
    { {     280}, {  138} }, // BLOCK 
    { {       0}, { -149} },          
};

SR_ s_221[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -147} }, 
};

SR_ s_222[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -114} }, 
};

SR_ s_223[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  226} }, // reset
    { {       0}, { -145} },         
};

SR_ s_224[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -150} }, 
};

SR_ s_225[] =
{
    { { REQ_TOKEN}, {   2} },          
    { {        10}, { 227} }, // '\x0a'
    { {         0}, {   0} },          
};

SR_ s_226[] =
{
    { { DEF_RED}, {    1} }, 
    { {       0}, { -151} }, 
};

SR_ s_227[] =
{
    { { DEF_RED}, {    2} },         
    { {     373}, {  228} }, // reset
    { {       0}, { -145} },         
};

SR_ s_228[] =
{
    { { REQ_TOKEN}, {  30} },                          
    { {       374}, { 229} }, // _msCompound_regex_list
    { {       371}, { 221} }, // regexOrEOF            
    { {       370}, {  89} }, // _regex                
    { {       282}, {  90} }, // EOF_PATTERN           
    { {       369}, {  91} }, // _regex_unit           
    { {       367}, {  92} }, // _unit                 
    { {       364}, {  93} }, // _open_paren           
    { {        94}, {  94} }, // '^'                   
    { {        36}, {  95} }, // '$'                   
    { {       287}, {  96} }, // DOLLAR                
    { {       284}, {  97} }, // STRING                
    { {       283}, {  98} }, // RAWSTRING             
    { {       285}, {  99} }, // QUOTES                
    { {       288}, { 100} }, // ESCAPE_SEQUENCE       
    { {        46}, { 101} }, // '.'                   
    { {       363}, { 102} }, // _single_char          
    { {       360}, { 103} }, // characterclass        
    { {        40}, { 104} }, // '('                   
    { {       293}, { 105} }, // CHAR                  
    { {       345}, { 106} }, // combi_chars           
    { {       359}, { 107} }, // _cc_set               
    { {        44}, { 108} }, // ','                   
    { {        61}, { 109} }, // '='                   
    { {        45}, { 110} }, // '-'                   
    { {        39}, { 111} }, // '''                   
    { {       352}, { 112} }, // _cc_start             
    { {       353}, { 113} }, // _cc_negated           
    { {       289}, { 114} }, // CC_START              
    { {       290}, { 115} }, // CC_NEGATED            
    { {         0}, {   0} },                          
};

SR_ s_229[] =
{
    { { REQ_DEF}, {    1} }, 
    { {       0}, { -146} }, 
};


// State array:
SR_ *s_state[] =
{
  s_0,  s_1,  s_2,  s_3,  s_4,  s_5,  s_6,  s_7,  s_8,  s_9,
  s_10,  s_11,  s_12,  s_13,  s_14,  s_15,  s_16,  s_17,  s_18,  s_19,
  s_20,  s_21,  s_22,  s_23,  s_24,  s_25,  s_26,  s_27,  s_28,  s_29,
  s_30,  s_31,  s_32,  s_33,  s_34,  s_35,  s_36,  s_37,  s_38,  s_39,
  s_40,  s_41,  s_42,  s_43,  s_44,  s_45,  s_46,  s_47,  s_48,  s_49,
  s_50,  s_51,  s_52,  s_53,  s_54,  s_55,  s_56,  s_57,  s_58,  s_59,
  s_60,  s_61,  s_62,  s_63,  s_64,  s_65,  s_66,  s_67,  s_68,  s_69,
  s_70,  s_71,  s_72,  s_73,  s_74,  s_75,  s_76,  s_77,  s_78,  s_79,
  s_80,  s_81,  s_82,  s_83,  s_84,  s_85,  s_86,  s_87,  s_88,  s_89,
  s_90,  s_91,  s_92,  s_93,  s_94,  s_95,  s_96,  s_97,  s_98,  s_99,
  s_100,  s_101,  s_102,  s_103,  s_104,  s_105,  s_106,  s_107,  s_108,  s_109,
  s_110,  s_111,  s_112,  s_113,  s_114,  s_115,  s_116,  s_117,  s_118,  s_119,
  s_120,  s_121,  s_122,  s_123,  s_124,  s_125,  s_126,  s_127,  s_128,  s_129,
  s_130,  s_131,  s_132,  s_133,  s_134,  s_135,  s_136,  s_137,  s_138,  s_139,
  s_140,  s_141,  s_142,  s_143,  s_144,  s_145,  s_146,  s_147,  s_148,  s_149,
  s_150,  s_151,  s_152,  s_153,  s_154,  s_155,  s_156,  s_157,  s_158,  s_159,
  s_160,  s_161,  s_162,  s_163,  s_164,  s_165,  s_166,  s_167,  s_168,  s_169,
  s_170,  s_171,  s_172,  s_173,  s_174,  s_175,  s_176,  s_177,  s_178,  s_179,
  s_180,  s_181,  s_182,  s_183,  s_184,  s_185,  s_186,  s_187,  s_188,  s_189,
  s_190,  s_191,  s_192,  s_193,  s_194,  s_195,  s_196,  s_197,  s_198,  s_199,
  s_200,  s_201,  s_202,  s_203,  s_204,  s_205,  s_206,  s_207,  s_208,  s_209,
  s_210,  s_211,  s_212,  s_213,  s_214,  s_215,  s_216,  s_217,  s_218,  s_219,
  s_220,  s_221,  s_222,  s_223,  s_224,  s_225,  s_226,  s_227,  s_228,  s_229,
};

using SMap = std::unordered_map<int, char const *>;
using SMapVal = SMap::value_type;

SMapVal s_symArr[] =
{
    SMapVal(-2, "Reserved_::UNDETERMINED_"),  // predefined symbols
    SMapVal(-1, "Reserved_::EOF_"),
    SMapVal(256, "errTok_"),

    SMapVal(257, "EXCL_START_CONDITION"),
    SMapVal(258, "INCL_START_CONDITION"),
    SMapVal(259, "SECTION_DELIMITER"),
    SMapVal(260, "BASECLASSHEADER"),
    SMapVal(261, "BASECLASSPREINCLUDE"),
    SMapVal(262, "CASEINSENSITIVE"),
    SMapVal(263, "CLASSHEADER"),
    SMapVal(264, "CLASSNAME"),
    SMapVal(265, "DEBUG"),
    SMapVal(266, "FILENAMES"),
    SMapVal(267, "IMPLEMENTATIONHEADER"),
    SMapVal(268, "INPUTIMPLEMENTATION"),
    SMapVal(269, "INPUTINLINE"),
    SMapVal(270, "INPUTINTERFACE"),
    SMapVal(271, "INTERACTIVE"),
    SMapVal(272, "LEXFUNCTIONNAME"),
    SMapVal(273, "LEXSOURCE"),
    SMapVal(274, "NAMESPACE"),
    SMapVal(275, "NOLINES"),
    SMapVal(276, "PRINT"),
    SMapVal(277, "SKELETON_DIRECTORY"),
    SMapVal(278, "STARTCONDITION"),
    SMapVal(279, "TARGET_DIRECTORY"),
    SMapVal(280, "BLOCK"),
    SMapVal(281, "IDENTIFIER"),
    SMapVal(282, "EOF_PATTERN"),
    SMapVal(283, "RAWSTRING"),
    SMapVal(284, "STRING"),
    SMapVal(285, "QUOTES"),
    SMapVal(286, "DECIMAL"),
    SMapVal(287, "DOLLAR"),
    SMapVal(288, "ESCAPE_SEQUENCE"),
    SMapVal(289, "CC_START"),
    SMapVal(290, "CC_NEGATED"),
    SMapVal(291, "PREDEFINED_CLASS"),
    SMapVal(292, "ORNL"),
    SMapVal(293, "CHAR"),
    SMapVal(294, "CC_PLUS"),
    SMapVal(295, "CC_MINUS"),
    SMapVal(313, "input"),
    SMapVal(314, "opt_directives"),
    SMapVal(315, "section_delimiter"),
    SMapVal(316, "rules"),
    SMapVal(317, "identifier"),
    SMapVal(318, "_sc_name"),
    SMapVal(319, "_start_condition_type"),
    SMapVal(320, "_start_condition_names"),
    SMapVal(321, "_start_condition_directive"),
    SMapVal(322, "_name_def"),
    SMapVal(323, "_stringType"),
    SMapVal(324, "_name_definition"),
    SMapVal(325, "_directive"),
    SMapVal(326, "option"),
    SMapVal(327, "_directive_line"),
    SMapVal(328, "_baseclassheader"),
    SMapVal(329, "_baseclasspreinclude"),
    SMapVal(330, "_classheader"),
    SMapVal(331, "_classname"),
    SMapVal(332, "_filenames"),
    SMapVal(333, "_implementationheader"),
    SMapVal(334, "_inputinline"),
    SMapVal(335, "_inputinterface"),
    SMapVal(336, "_inputimplementation"),
    SMapVal(337, "_lexfunctionname"),
    SMapVal(338, "_lexsource"),
    SMapVal(339, "_namespace"),
    SMapVal(340, "_skeleton_directory"),
    SMapVal(341, "_startcondition_name"),
    SMapVal(342, "_target_directory"),
    SMapVal(343, "_stringOrIdent"),
    SMapVal(344, "_opt_is"),
    SMapVal(345, "combi_chars"),
    SMapVal(346, "_ms_name"),
    SMapVal(347, "_ms_name_list"),
    SMapVal(348, "_ms_specs"),
    SMapVal(349, "_ms_angular"),
    SMapVal(350, "ms_spec"),
    SMapVal(351, "_m_content"),
    SMapVal(352, "_cc_start"),
    SMapVal(353, "_cc_negated"),
    SMapVal(354, "_cc_end"),
    SMapVal(355, "_cc_literal"),
    SMapVal(356, "_cc_escape"),
    SMapVal(357, "_cc_element"),
    SMapVal(358, "_cc_content"),
    SMapVal(359, "_cc_set"),
    SMapVal(360, "characterclass"),
    SMapVal(361, "_decimal"),
    SMapVal(362, "_interval"),
    SMapVal(363, "_single_char"),
    SMapVal(364, "_open_paren"),
    SMapVal(365, "_close_paren"),
    SMapVal(366, "_open_curly"),
    SMapVal(367, "_unit"),
    SMapVal(368, "_quantifier"),
    SMapVal(369, "_regex_unit"),
    SMapVal(370, "_regex"),
    SMapVal(371, "regexOrEOF"),
    SMapVal(372, "action"),
    SMapVal(373, "reset"),
    SMapVal(374, "_msCompound_regex_list"),
    SMapVal(375, "_msCompound_rule"),
    SMapVal(376, "_msCompound_nl_rule"),
    SMapVal(377, "_opt_msCompound_nl_rules"),
    SMapVal(378, "msCompound"),
    SMapVal(379, "_optMs_regex"),
    SMapVal(380, "_optMs_rule"),
    SMapVal(381, "optMs_rule"),
    SMapVal(382, "_rule_def"),
    SMapVal(383, "_rule"),
    SMapVal(384, "input_$"),
};

SMap s_symbol
(
    s_symArr, s_symArr + sizeof(s_symArr) / sizeof(SMapVal)
);

} // anonymous namespace ends



// $insert polymorphicCode
namespace Meta_
{

size_t const *t_nErrors;
// $insert idoftag
char const *idOfTag_[] = {
    "VECTOR",
    "INTERVAL",
    "CHARCLASS",
    "PATTERN",
    "STRING",
    "TEXTTYPE",
    "EndPolyType_"
};

size_t const *s_nErrors_;

Base::~Base()
{}

}   // namespace Meta_

// If the parsing function call (i.e., parse()' needs arguments, then provide
// an overloaded function.  The code below doesn't rely on parameters, so no
// arguments are required.  Furthermore, parse uses a function try block to
// allow us to do ACCEPT and ABORT from anywhere, even from within members
// called by actions, simply throwing the appropriate exceptions.


// base/base1
ParserBase::ParserBase()
:
    d_token(Reserved_::UNDETERMINED_),
    // $insert baseclasscode
    d_requiredTokens_(0)
{
    Meta_::t_nErrors = &d_nErrors_;
}

// base/clearin
void ParserBase::clearin_()
{
    d_nErrors_ = 0;
    d_stackIdx = -1;
    d_stateStack.clear();
    d_token = Reserved_::UNDETERMINED_;
    d_next = TokenPair{ Reserved_::UNDETERMINED_, STYPE_{} };
    d_recovery = false;
    d_acceptedTokens_ = d_requiredTokens_;
    d_val_ = STYPE_{};

    push_(0);
}

// base/debugfunctions
// $insert debugfunctions
std::ostringstream ParserBase::s_out_;
std::ostream &ParserBase::dflush_(std::ostream &out)
{
    std::ostringstream &s_out_ = dynamic_cast<std::ostringstream &>(out);

    std::cout << "    " << s_out_.str() << std::flush;
    s_out_.clear();
    s_out_.str("");
    return out;
}

std::string ParserBase::stype_(char const *pre, 
                 STYPE_ const &semVal, char const *post) const
{
    return "";
}
std::string ParserBase::symbol_(int value) const
{
    using namespace std;
    ostringstream ostr;
    SMap::const_iterator it = s_symbol.find(value);
    if (it != s_symbol.end())
        ostr << '\'' << it->second << '\'';
    else if (isprint(value))
        ostr << '`' << static_cast<char>(value) << "' (" << value << ')';
    else
        ostr << "'\\x" << setfill('0') << hex << setw(2) << value << '\'';
    return ostr.str();
}



void ParserBase::setDebug(bool mode)
{
    d_actionCases_ = false;
    d_debug_ = mode;
}

void ParserBase::setDebug(DebugMode_ mode)
{
    d_actionCases_ = mode & ACTIONCASES;
    d_debug_ =       mode & ON;
}

// base/lex
void ParserBase::lex_(int token)
{
    d_token = token;

    if (d_token <= 0)
        d_token = Reserved_::EOF_;

    d_terminalToken = true;
}

// base/lookup
int ParserBase::lookup_() const
{
    // if the final transition is negative, then we should reduce by the rule
    // given by its positive value.

    SR_ const *sr = s_state[d_state];
    SR_ const *last = sr + sr->d_lastIdx;

    for ( ; ++sr != last; )           // visit all but the last SR entries
    {
        if (sr->d_token == d_token)
            return sr->d_action;
    }

    if (sr == last)   // reached the last element
    {
        if (sr->d_action < 0)   // default reduction
        {
            // $insert debug
            if (d_debug_)
                s_out_ <<  "\nLOOKUP: [" << state_() << ", " << symbol_(d_token) << "] -> default reduce using rule " << -sr->d_action << '\n' << dflush_;
            return sr->d_action;                
        }

        // No default reduction, so token not found, so error.
        throw UNEXPECTED_TOKEN_;
    }

    // not at the last element: inspect the nature of the action
    // (< 0: reduce, 0: ACCEPT, > 0: shift)

    int action = sr->d_action;

// $insert debuglookup
    if (d_debug_)
    {
        s_out_ <<  "encountered " << symbol_(token_()) << " in state " <<
                    state_() << ": ";
    
        if (action < 0)             // a reduction was found
            s_out_ << ": reducing by rule " << -action;
        else if (action == 0)
            s_out_ <<  "ACCEPT";
        else
            s_out_ <<  "next state: " << action;
    
        s_out_ << '\n' << dflush_;
    }

    return action;
}

// base/pop
void ParserBase::pop_(size_t count)
{
    // $insert debug
    if (d_debug_)
        s_out_ <<  "pop " << count << " elements from the stack having size " << stackSize_() << '\n' << dflush_;
    if (d_stackIdx < static_cast<int>(count))
    {
        // $insert debug
        if (d_debug_)
            s_out_ <<  "Terminating parse(): state stack underflow  at token " << symbol_(d_token) << '\n' << dflush_;
        ABORT();
    }

    d_stackIdx -= count;
    d_state = d_stateStack[d_stackIdx].first;
    d_vsp = &d_stateStack[d_stackIdx];

    // $insert debug
    if (d_debug_)
        s_out_ <<  "next: [" << state_() << ", " << symbol_(d_token) << ']' << stype_(". Semantic: ", vs_(0)) << '\n' << dflush_;
}

// base/poptoken
void ParserBase::popToken_()
{
    d_token = d_next.first;
    d_val_ = d_token >= 0 ? std::move(d_next.second) : STYPE_{};

    d_next.first = Reserved_::UNDETERMINED_;
}

// base/push
void ParserBase::push_(size_t state)
{
    size_t currentSize = d_stateStack.size();
    if (stackSize_() == currentSize)
    {
        size_t newSize = currentSize + STACK_EXPANSION_;
        d_stateStack.resize(newSize);
    }

    ++d_stackIdx;
    d_stateStack[d_stackIdx] = 
                    StatePair{ d_state = state, std::move(d_val_) };

    d_vsp = &d_stateStack[d_stackIdx];

    if (d_stackIdx == 0)
    {
    // $insert debug
    if (d_debug_)
        s_out_ <<   "\nPUSH 0 (initializing the state stack)" << '\n' << dflush_;
    }
    else
    {
    // $insert debug
    if (d_debug_)
        s_out_ <<   "\nPUSH:   [" << (d_vsp - 1)->first << ", " << symbol_(d_token) << "] -> " << state << stype_(" (semantic TOS = ", d_val_, ")") << '\n' << dflush_;
    }
}

// base/pushtoken
void ParserBase::pushToken_(int token)
{
    d_next = TokenPair{ d_token, std::move(d_val_) };
    d_token = token;
}

// base/redotoken
void ParserBase::redoToken_()
{
    if (d_token != Reserved_::UNDETERMINED_)
        pushToken_(d_token);
}

// base/reduce
void ParserBase::reduce_(int rule)
{
    PI_ const &pi = s_productionInfo[rule];

    d_token = pi.d_nonTerm;
    // $insert debug
    if (d_debug_)
        s_out_ <<  "rule " << (&pi - s_productionInfo) << ": pop " << pi.d_size << " elements. Next will be: [" << d_stateStack[d_stackIdx - pi.d_size].first << ", " << symbol_(d_token) << ']' << '\n' << dflush_;
    pop_(pi.d_size);

    d_terminalToken = false;
}

// base/shift
void ParserBase::shift_(int action)
{
    push_(action);
    popToken_();               // token processed

    if (d_recovery and d_terminalToken)
    {
        // $insert debug
        if (d_debug_)
            s_out_ <<  "ERROR RECOVERED: next state " << action << '\n' << dflush_;
        d_recovery = false;
        d_acceptedTokens_ = 0;
    }
}

// base/startrecovery
void ParserBase::startRecovery_()
{
    int lastToken = d_token;                // give the unexpected token a
                                            // chance to be processed
                                            // again.

    pushToken_(Reserved_::errTok_);      // specify errTok_ as next token
    push_(lookup_());                     // push the error state

    d_token = lastToken;                    // reactivate the unexpected
                                            // token (we're now in an
                                            // ERROR state).

    d_recovery = true;
}

// base/top
inline size_t ParserBase::top_() const
{
    return d_stateStack[d_stackIdx].first;
}

// derived/errorrecovery
void Parser::errorRecovery_()
{
    // When an error has occurred, pop elements off the stack until the top
    // state has an error-item. If none is found, the default recovery
    // mode (which is to abort) is activated. 
    //
    // If EOF is encountered without being appropriate for the current state,
    // then the error recovery will fall back to the default recovery mode.
    // (i.e., parsing terminates)

    // $insert debug
    if (d_debug_)
        s_out_ <<  "\nERROR:  [" << top_() << ", " << symbol_(token_()) << "] -> ??. Errors: " << (d_nErrors_ + 1) << '\n' << dflush_;


    if (d_acceptedTokens_ >= d_requiredTokens_)// only generate an error-
    {                                           // message if enough tokens 
        ++d_nErrors_;                          // were accepted. Otherwise
        error();                                // simply skip input
    }

    // get the error state
    while (not (s_state[top_()][0].d_type & ERR_ITEM))
    {
        // $insert debug
        if (d_debug_)
            s_out_ <<  "pop state: " << top_() << " (not an ERROR state)" << '\n' << dflush_;
        pop_();
    }
    // $insert debug
    if (d_debug_)
        s_out_ <<  "Reached ERROR state " << top_() << '\n' << dflush_;

    // In the error state, looking up a token allows us to proceed.
    // Continuation may be require multiple reductions, but eventually a
    // terminal-token shift is used. See nextCycle_ for details.

    startRecovery_();
}

// derived/executeaction
void Parser::executeAction_(int production)
try
{
    if (token_() != Reserved_::UNDETERMINED_)
        pushToken_(token_());     // save an already available token
    // $insert debug
    if (d_debug_)
        s_out_ <<  "execute action " << production << " ..." << '\n' << dflush_;
// $insert executeactioncases

    if (d_actionCases_)
        s_out_ << "executeAction case " << production << '\n' << dflush_;
    switch (production)
    {
        // $insert actioncases
        
        case 2:
#line 92 "grammar"
        {
         d_nLOPstartConditions = d_rules.startConditions().size();
         d_rules.setEndUserSC();
         reset();
         }
        break;

        case 3:
#line 101 "grammar"
        {
         d_val_ = d_matched;
         }
        break;

        case 4:
#line 2 "inc/directives"
        {
         d_expect = "list of start condition names";
         }
        break;

        case 5:
#line 10 "inc/directives"
        {
         d_rules.setType(StartConditions::INCLUSIVE);
         }
        break;

        case 6:
#line 16 "inc/directives"
        {
         d_rules.setType(StartConditions::EXCLUSIVE);
         }
        break;

        case 7:
#line 23 "inc/directives"
        {
         d_rules.defineStartCondition(vs_(0).get<Tag_::STRING>());
         }
        break;

        case 8:
#line 28 "inc/directives"
        {
         d_rules.defineStartCondition(vs_(0).get<Tag_::STRING>());
         }
        break;

        case 10:
#line 40 "inc/directives"
        {
         d_scanner.newDefinition(); 
         d_val_ = d_scanner.matched();
         }
        break;

        case 11:
#line 48 "inc/directives"
        {
         d_val_ = TextType::STRING;
         }
        break;

        case 12:
#line 53 "inc/directives"
        {
         d_val_ = rawString();
         }
        break;

        case 13:
#line 60 "inc/directives"
        {
         d_scanner.addDefinition(vs_(-1).get<Tag_::STRING>(), vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 22:
#line 3 "inc/options"
        {
         d_expect = "scanner base class header file name";
         }
        break;

        case 23:
#line 10 "inc/options"
        {
         d_expect = "base class preinclude file name";
         }
        break;

        case 24:
#line 17 "inc/options"
        {
         d_expect = "scanner class header file name";
         }
        break;

        case 25:
#line 24 "inc/options"
        {
         d_expect = "class name";
         }
        break;

        case 26:
#line 31 "inc/options"
        {
         d_expect = "generic filenames specification";
         }
        break;

        case 27:
#line 38 "inc/options"
        {
         d_expect = "implementation header file name";
         }
        break;

        case 28:
#line 45 "inc/options"
        {
         d_expect = "name of the file holding Input's inline implementations";
         }
        break;

        case 29:
#line 52 "inc/options"
        {
         d_expect = "name of the file holding Input's interface";
         }
        break;

        case 30:
#line 59 "inc/options"
        {
         d_expect = "name of the file holding Input's implementations";
         }
        break;

        case 31:
#line 66 "inc/options"
        {
         d_expect = "name of the lex() function";
         }
        break;

        case 32:
#line 73 "inc/options"
        {
         d_expect = "source file name of the lex function";
         }
        break;

        case 33:
#line 80 "inc/options"
        {
         d_expect = "name of the namespace to use";
         }
        break;

        case 34:
#line 87 "inc/options"
        {
         d_expect = "directory name of the flexc++ skeleton files";
         }
        break;

        case 35:
#line 94 "inc/options"
        {
         d_expect = "start-condition enum name";
         }
        break;

        case 36:
#line 101 "inc/options"
        {
         d_expect = "target directory name for generated files";
         }
        break;

        case 37:
#line 108 "inc/options"
        {
         d_val_ = TextType::STRING;
         }
        break;

        case 38:
#line 113 "inc/options"
        {
         d_val_ = TextType::IDENT;
         }
        break;

        case 39:
#line 118 "inc/options"
        {
         d_val_ = rawString();
         }
        break;

        case 42:
#line 131 "inc/options"
        {
         d_options.setInputInterfacePath(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 43:
#line 136 "inc/options"
        {
         d_options.setInputImplementationPath(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 44:
#line 141 "inc/options"
        {
         d_options.setInputInlinePath(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 45:
#line 146 "inc/options"
        {
         d_options.setClassName(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 46:
#line 151 "inc/options"
        {
         d_options.setFilenames(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 47:
#line 156 "inc/options"
        {
         d_options.setLexFunctionName(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 48:
#line 161 "inc/options"
        {
         d_options.setBaseClassHeader(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 49:
#line 166 "inc/options"
        {
         d_options.setBaseClassPreinclude(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 50:
#line 171 "inc/options"
        {
         d_options.setClassHeader(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 51:
#line 176 "inc/options"
        {
         d_options.setImplementationHeader(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 52:
#line 181 "inc/options"
        {
         d_options.setLexSource(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 53:
#line 186 "inc/options"
        {
         d_options.setSkeletonDirectory(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 54:
#line 191 "inc/options"
        {
         d_options.setStartConditionName(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 55:
#line 196 "inc/options"
        {
         d_options.setTargetDirectory(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 56:
#line 201 "inc/options"
        {
         d_options.setNameSpace(vs_(0).get<Tag_::TEXTTYPE>());
         }
        break;

        case 57:
#line 206 "inc/options"
        {
         d_options.setCaseInsensitive();
         }
        break;

        case 58:
#line 211 "inc/options"
        {
         d_options.setInteractive();
         }
        break;

        case 59:
#line 216 "inc/options"
        {
         d_options.setPrint();
         }
        break;

        case 60:
#line 221 "inc/options"
        {
         d_options.setLines(false);
         }
        break;

        case 61:
#line 226 "inc/options"
        {
         d_options.setDebug();
         }
        break;

        case 66:
#line 3 "inc/msspec"
        {
         d_rules.addStartCondition(vs_(0).get<Tag_::STRING>());
         }
        break;

        case 69:
#line 16 "inc/msspec"
        { 
         d_rules.useAll();
         }
        break;

        case 71:
#line 25 "inc/msspec"
        {
         d_scanner.acceptMulti();
         d_scanner.forceCaseSensitive();
         }
        break;

        case 72:
#line 33 "inc/msspec"
        {
         d_scanner.ignoreWS();
         d_scanner.multiAsChar();
         }
        break;

        case 73:
#line 2 "inc/characterclass"
        {
         d_expect = "character class";
         }
        break;

        case 74:
#line 10 "inc/characterclass"
        {
         d_val_ = CharClass(d_matched, 1); 
         }
        break;

        case 75:
#line 18 "inc/characterclass"
        { 
         d_val_ = CharClass(d_matched, 2); 
         }
        break;

        case 76:
#line 25 "inc/characterclass"
        {
         d_expect = "pattern or action block";
         }
        break;

        case 100:
#line 83 "inc/characterclass"
        {
         d_val_ = CharClass::chars(d_matched);
         }
        break;

        case 101:
#line 88 "inc/characterclass"
        {
         d_val_ = CharClass::predefined(d_matched);
         }
        break;

        case 102:
#line 93 "inc/characterclass"
        {
         d_val_ = CharClass::chars(d_matched);
         }
        break;

        case 103:
#line 100 "inc/characterclass"
        {
         d_val_ = vs_(-1).get<Tag_::VECTOR>();
         d_val_.get<Tag_::VECTOR>().push_back(vs_(0).get<Tag_::STRING>());
         }
        break;

        case 104:
#line 106 "inc/characterclass"
        {
         d_val_ = vector<string>(1, vs_(0).get<Tag_::STRING>());
         }
        break;

        case 105:
#line 113 "inc/characterclass"
        {
         d_val_ = vs_(-1).get<Tag_::CHARCLASS>();
         }
        break;

        case 106:
#line 118 "inc/characterclass"
        {
         d_val_ = vs_(-1).get<Tag_::CHARCLASS>();
         d_val_.get<Tag_::CHARCLASS>().negate();
         }
        break;

        case 107:
#line 124 "inc/characterclass"
        {
         d_val_ = vs_(-2).get<Tag_::CHARCLASS>();
         d_val_.get<Tag_::CHARCLASS>().append(vs_(-1).get<Tag_::VECTOR>());
         }
        break;

        case 108:
#line 130 "inc/characterclass"
        {
         d_val_ = vs_(-2).get<Tag_::CHARCLASS>();
         d_val_.get<Tag_::CHARCLASS>().negate(vs_(-1).get<Tag_::VECTOR>());
         }
        break;

        case 109:
#line 138 "inc/characterclass"
        {
         d_val_ = CharClass::unite(vs_(-2).get<Tag_::CHARCLASS>(), vs_(0).get<Tag_::CHARCLASS>());
         }
        break;

        case 110:
#line 143 "inc/characterclass"
        {
         d_val_ = CharClass::difference(vs_(-2).get<Tag_::CHARCLASS>(), vs_(0).get<Tag_::CHARCLASS>());
         }
        break;

        case 111:
#line 148 "inc/characterclass"
        {
         d_val_ = vs_(0).get<Tag_::CHARCLASS>();
         }
        break;

        case 112:
#line 3 "inc/regexoreof"
        {
         d_val_ = d_matched;
         }
        break;

        case 113:
#line 10 "inc/regexoreof"
        {
         d_val_ = Interval::exact(vs_(0).get<Tag_::STRING>());
         }
        break;

        case 114:
#line 15 "inc/regexoreof"
        {
         d_val_ = Interval::range(vs_(-2).get<Tag_::STRING>(), vs_(0).get<Tag_::STRING>());
         }
        break;

        case 115:
#line 20 "inc/regexoreof"
        {
         d_val_ = Interval::lowerBound(vs_(-1).get<Tag_::STRING>());
         }
        break;

        case 118:
#line 33 "inc/regexoreof"
        {
         ++d_parentheses;
         }
        break;

        case 119:
#line 40 "inc/regexoreof"
        {
         --d_parentheses;
         }
        break;

        case 120:
#line 47 "inc/regexoreof"
        {
         d_scanner.acceptMulti();
         }
        break;

        case 121:
#line 54 "inc/regexoreof"
        {
         d_val_ = boln();
         }
        break;

        case 122:
#line 59 "inc/regexoreof"
        {
         d_val_ = dollar();
         }
        break;

        case 123:
#line 64 "inc/regexoreof"
        {
         d_val_ = eolnDollar();
         }
        break;

        case 124:
#line 69 "inc/regexoreof"
        {
         d_val_ = str();
         }
        break;

        case 125:
#line 74 "inc/regexoreof"
        {
         d_val_ = rawText(d_scanner.rawStringContent());
         }
        break;

        case 126:
#line 79 "inc/regexoreof"
        { 
         d_val_ = quotes();
         }
        break;

        case 127:
#line 84 "inc/regexoreof"
        {
         d_val_ = escape();
         }
        break;

        case 128:
#line 89 "inc/regexoreof"
        {
         d_val_ = FPattern::dot(d_states);
         }
        break;

        case 129:
#line 94 "inc/regexoreof"
        {
         d_val_ = rawText();
         }
        break;

        case 130:
#line 99 "inc/regexoreof"
        {
         d_val_ = FPattern::characterClass(d_states, vs_(0).get<Tag_::CHARCLASS>());
         }
        break;

        case 134:
#line 114 "inc/regexoreof"
        {
         Options::regexCall("unit");
         d_val_ = vs_(0).get<Tag_::PATTERN>(); 
         }
        break;

        case 135:
#line 120 "inc/regexoreof"
        {
         d_val_ = interval(vs_(-3).get<Tag_::PATTERN>(), vs_(-1).get<Tag_::INTERVAL>());
         }
        break;

        case 136:
#line 125 "inc/regexoreof"
        {
         d_val_ = FPattern::quantifier(d_states, vs_(-1).get<Tag_::PATTERN>(), d_matched[0]);
         }
        break;

        case 137:
#line 130 "inc/regexoreof"
        {
         d_val_ = vs_(-1).get<Tag_::PATTERN>();
         }
        break;

        case 138:
#line 135 "inc/regexoreof"
        {
         d_val_ = FPattern::concatenate(d_states, vs_(-1).get<Tag_::PATTERN>(), vs_(0).get<Tag_::PATTERN>());
         }
        break;

        case 139:
#line 147 "inc/regexoreof"
        {
         Options::regexCall("regex-unit");
         d_val_ = vs_(0).get<Tag_::PATTERN>();
         }
        break;

        case 140:
#line 153 "inc/regexoreof"
        { 
         d_val_ = FPattern::alternatives(d_states, vs_(-2).get<Tag_::PATTERN>(), vs_(0).get<Tag_::PATTERN>());
         }
        break;

        case 141:
#line 158 "inc/regexoreof"
        {
         d_val_ = lookahead(vs_(-2).get<Tag_::PATTERN>(), vs_(0).get<Tag_::PATTERN>());
         }
        break;

        case 142:
#line 165 "inc/regexoreof"
        {
         d_val_ = vs_(0).get<Tag_::PATTERN>();
         }
        break;

        case 143:
#line 170 "inc/regexoreof"
        {
         d_val_ = FPattern::eof(d_states);
         }
        break;

        case 144:
#line 6 "inc/action"
        {
         block(); 
         }
        break;

        case 145:
#line 2 "inc/reset"
        {
         reset();
         }
        break;

        case 146:
#line 5 "inc/mscompound"
        {
         orAction();
         }
        break;

        case 147:
#line 10 "inc/mscompound"
        {
         addRule(vs_(0).get<Tag_::PATTERN>());
         }
        break;

        case 149:
#line 21 "inc/mscompound"
        {
         noActions();
         }
        break;

        case 150:
#line 26 "inc/mscompound"
        {
         assignBlock();
         }
        break;

        case 154:
#line 43 "inc/mscompound"
        { 
         d_rules.resetStartConditions();
         }
        break;

        case 155:
#line 4 "inc/optmsrule"
        {
         d_val_ = vs_(0).get<Tag_::PATTERN>();
         }
        break;

        case 156:
#line 9 "inc/optmsrule"
        {
         d_val_ = vs_(0).get<Tag_::PATTERN>();
         }
        break;

        case 157:
#line 23 "inc/optmsrule"
        {
         orAction();
         }
        break;

        case 158:
#line 28 "inc/optmsrule"
        {
         addRule(vs_(0).get<Tag_::PATTERN>(), true); 
         }
        break;

        case 160:
#line 40 "inc/optmsrule"
        {
         assignBlock();
         }
        break;

    }
    // $insert debug
    if (d_debug_)
        s_out_ <<  "... completed" << stype_(", semantic: ", vs_(0)) << '\n' << dflush_;
}
catch (std::exception const &exc)
{
    exceptionHandler(exc);
}

// derived/nextcycle
void Parser::nextCycle_()
try
{
    if (s_state[state_()]->d_type & REQ_TOKEN)
        nextToken_();              // obtain next token


    int action = lookup_();        // lookup d_token in d_state

    if (action > 0)                 // SHIFT: push a new state
    {
        shift_(action);
        return;
    }

    if (action < 0)            // REDUCE: execute and pop.
    {
        // $insert debug
        if (d_debug_)
            s_out_ <<  "\nREDUCE: rule " << -action << '\n' << dflush_;

        if (recovery_())
            redoToken_();
        else
            executeAction_(-action);
                                            // next token is the rule's LHS
        reduce_(-action); 
        return;
    }

    if (recovery_())
        ABORT();
    else 
        ACCEPT();
}
catch (ErrorRecovery_)
{
    if (not recovery_())
        errorRecovery_();
    else
    {
        if (token_() == Reserved_::EOF_)
            ABORT();
        popToken_();               // skip the failing token
    }
}


// derived/nexttoken
void Parser::nextToken_()
{ 
    // If d_token is Reserved_::UNDETERMINED_ then if savedToken_() is
    // Reserved_::UNDETERMINED_ another token is obtained from lex(). Then
    // savedToken_() is assigned to d_token.

                                    // no need for a token: got one already
    if (token_() != Reserved_::UNDETERMINED_) 
    {
        // $insert debug
        if (d_debug_)
            s_out_ <<  "available token " << symbol_(token_()) << '\n' << dflush_;
        return;                             
    }

    if (savedToken_() != Reserved_::UNDETERMINED_)
    {
        popToken_();               // consume pending token
        // $insert debug
        if (d_debug_)
            s_out_ <<  "retrieved token " << symbol_(token_()) << stype_(", semantic = ", d_val_) << '\n' << dflush_;
    }
    else
    {
        ++d_acceptedTokens_;       // accept another token (see
                                    // errorRecover())
        lex_(lex());
        print_();
        // $insert debug
        if (d_debug_)
            s_out_ <<  "scanner token " << symbol_(token_()) << '\n' << dflush_;
    }
    print();
}

// derived/print
void Parser::print_()
{
// $insert print
}

// derived/parse
int Parser::parse()
try 
{
    // The parsing algorithm:
    // Initially, state 0 is pushed on the stack, and all relevant variables
    // are initialized by Base::clearin_.
    //
    // Then, in an eternal loop:
    //
    //  1. If a state is a REQ_TOKEN type, then the next token is obtained
    //     from nextToken().  This may very well be the currently available
    //     token. When retrieving a terminal token d_terminal is set to true.
    //
    //  2. lookup() is called, d_token is looked up in the current state's
    //     SR_ array.
    //
    //  4. Depending on the result of the lookup() function the next state is
    //     shifted on the parser's stack, a reduction by some rule is applied,
    //     or the parsing function returns ACCEPT(). When a reduction is
    //     called for, any action that may have been defined for that
    //     reduction is executed.
    //
    //  5. An error occurs if d_token is not found, and the state has no
    //     default reduction.

    // $insert debug
    if (d_debug_)
        s_out_ <<  "parse(): Parsing starts" << '\n' << dflush_;
    clearin_();                            // initialize, push(0)

    while (true)
    {
// $insert prompt

        if (d_debug_)
            s_out_ << '\n';

        nextCycle_();
    }
}
catch (Return_ retValue)
{
    // $insert debug
    if (d_debug_)
        s_out_ <<  "parse(): returns " << retValue << " or " << d_nErrors_  << '\n' << dflush_;
    return retValue or d_nErrors_;
}


// derived/tail


